Name:           cherryrgb
Version:        0.2.8
Release:        3%{?dist}
Summary:        Cherry RGB Keyboard control software
License:        MIT
Group:          Utilities
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%{?systemd_requires}

BuildRequires:  rust-packaging
BuildRequires:  systemd-rpm-macros
BuildRequires:  llvm-devel
BuildRequires:  clang-devel

%global forgeurl        https://github.com/skraus-dev/cherryrgb-rs
%global forgesource0    %{forgeurl}/archive/refs/tags/%{version}.tar.gz
%global archiveurl0     %{forgeurl}/archive/refs/tags/%{version}.tar.gz

%forgemeta -a -i

Source0:        %{forgesource0}
URL:            %{forgeurl0}

%description
%{name} provides a commandline tool for configuring various RGB keyboards made by cherry.

%prep
%forgesetup -a
cargo fetch --locked

%build
cargo build --frozen --release --all-features --all
cargo xtask all

%install
%{__install} -D -m 0755 -t %{buildroot}%{_bindir} target/release/cherryrgb_cli
%{__install} -D -m 0755 -t %{buildroot}%{_bindir} target/release/cherryrgb_ncli
%{__install} -D -m 0755 -t %{buildroot}%{_libexecdir} target/release/cherryrgb_service
%{__install} -D -m 0644 -t %{buildroot}%{_udevrulesdir} udev/99-cherryrgb-service.rules
%{__install} -D -m 0644 -t %{buildroot}%{_unitdir} service/etc/systemd/system/cherryrgb.service
%{__install} -D -m 0644 -t %{buildroot}%{_sysconfdir}/default service/etc/default/cherryrgb
%{__install} -D -m 0644 -t %{buildroot}%{_docdir}/%{name} docs/* examples/* README.md
%{__install} -D -m 0644 -t %{buildroot}%{_datadir}/bash-completion/completions target/generated/completions/*.bash
%{__install} -D -m 0644 -t %{buildroot}%{_datadir}/zsh/site-functions target/generated/completions/_*
%{__install} -D -m 0644 -t %{buildroot}%{_mandir}/man1 target/generated/man/*.1
%{__install} -D -m 0644 -t %{buildroot}%{_mandir}/man8 target/generated/man/*.8

%clean
rm -rf %{buildroot}

%post
%systemd_post cherryrgb.service

%preun
%systemd_preun cherryrgb.service

%postun
%systemd_postun_with_restart cherryrgb.service

%files
%defattr(-,root,root,-)
%{_bindir}/*
%{_libexecdir}/*
%{_udevrulesdir}/*
%{_unitdir}/*
%config(noreplace) %{_sysconfdir}/default/*
%{_mandir}/*
%{_datadir}/bash-completion/*
%{_datadir}/zsh/site-functions/*

%doc %{_docdir}/%{name}

%changelog
* Wed Nov  6 2024 Fritz Elfert <fritz@fritz-elfert.de>
- Rebuild for F40
* Wed Nov  6 2024 Fritz Elfert <fritz@fritz-elfert.de>
- Rebuild for F40
* Sun Jun 18 2023 Fritz Elfert <fritz@fritz-elfert.de>
- Bump up version to 0.2.8
* Sat Jun  3 2023 Fritz Elfert <fritz@fritz-elfert.de>
- Bump up version to 0.2.7
* Wed May 17 2023 Fritz Elfert <fritz@fritz-elfert.de>
- Bump up version to 0.2.5
* Sun Apr 30 2023 Fritz Elfert <fritz@fritz-elfert.de>
- Bump up version to 0.2.4
* Sun Apr 16 2023 Fritz Elfert <fritz@fritz-elfert.de>
- Initial packaging
